package Item21;

import java.util.ArrayList;
import java.util.List;

public class ItemManager {
    private List<Item> items = new ArrayList<>();
    private List<ItemProcess<Item>> processes = new ArrayList<>();
    private static int id = 1;
    
    public void addItem(Item i) {
	items.add(i);
    }
    
    public void addProcess(ItemProcess<Item> p) {
	processes.add(p);
    }
    
    public int generateID() {
	return id++;
    }
    
    public void execute() {
	for (Item item : items) {
	    item.setId(generateID());
	    for (ItemProcess<Item> itemProcess : processes) {
		itemProcess.process(item);
	    }
	}
    }
}
